# kubectl persistent logger

A side project to re-implement `kubectl logs` with an interface that is
friendlier for development usage. Specifically, this implementation
automatically updates to follow logs for new pods added to deployments, and
does not terminate upon pod termination, even if the replica count falls to
zero.

## Usage

To follow logs for all pods that are targeted by a specific deployment's selector:

```
go install git.netflux.io/rob/kubectl-persistent-logger
kubectl-persistent-logger -deployment mydeploymentname
```

## TODO

- [ ] Implement for other relevant resource types (replica set, stateful set)
- [ ] Pass other options back to logger backend (--container, etc)
- [x] Test coverage
- [ ] Improve context handling
- [ ] Remove/hide debug logging

## License

Copyright 2022 Rob Watson.

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
